<?php

add_action("widgets_init", array('CuteRecordsWidget', 'register'));


class CuteRecordsWidget extends WP_Widget {

	function register() { 

		register_widget("CuteRecordsWidget");

	}

	function CuteRecordsWidget() {

		$widget_ops = array('classname' => 'CuteRecordsWidget', 'description' => 'Displays a selected record.' );

		$this->WP_Widget('CuteRecordsWidget', 'CR Selected Record', $widget_ops);

	}

	function update($new_instance, $old_instance) { 

		$instance = $old_instance;

		$instance['title'] = $new_instance['title'];
		$instance['record_id'] = $new_instance['record_id'];
		$instance['url'] = $new_instance['url'];

		return $instance;

	}

	function form($instance) { 

		$instance = wp_parse_args( (array) $instance, array( 'title' => 'Latest Record', 'record_id' => '0', 'url' => '#' ) );

		$title = $instance['title'];
		$record_id = $instance['record_id'];
		$url = $instance['url'];

		?>

		<p>

			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Widget Title:'); ?> </label>

			<input type="text" id="<?php echo $this->get_field_id('title'); ?>" class="widefat" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo attribute_escape($title); ?>"><br>
			
			<label for="<?php echo $this->get_field_id('record_id'); ?>"><?php _e('Record ID:'); ?> </label>
			<input type="text" id="<?php echo $this->get_field_id('record_id'); ?>" class="widefat" name="<?php echo $this->get_field_name('record_id'); ?>" value="<?php echo attribute_escape($record_id); ?>"><br>
			
			<label for="<?php echo $this->get_field_id('url'); ?>"><?php _e('Link URL:'); ?> </label>
			<input type="text" id="<?php echo $this->get_field_id('url'); ?>" class="widefat" name="<?php echo $this->get_field_name('url'); ?>" value="<?php echo attribute_escape($url); ?>">

		</p>

		<?php

	}

	function widget($args, $instance){
		global $wpdb; 
		$uploads = wp_upload_dir();
		$baseurl = $uploads['baseurl'];
		
		if($instance['record_id'] > 0) { 
			$rec = $wpdb->get_row("SELECT cover FROM ".$wpdb->prefix."cuterecords WHERE id='".$instance['record_id']."'");
		} else { 
			$rec = $wpdb->get_row("SELECT cover FROM ".$wpdb->prefix."cuterecords ORDER BY releasedate DESC LIMIT 1");
		}
		
		if($rec) { 
			echo $args['before_widget'];
	
			$title = empty($instance['title']) ? ' ' : apply_filters('widget_title', $instance['title']);
	
			if (!empty($title)) {
	
				echo '<h3 class="widget-title">' . $title . '</h3>';
	
			} 
			
			echo '<div class="textwidget">';
			echo '<p align="center">';
			echo '<a target="_blank" href="'.esc_attr($instance['url']).'"><img class="cuterecords_image" alt="" src="'.$baseurl.'/covers/side/'.$rec->cover.'" width="'.cuterecords_SIDE_WIDTH.'"></a>';
			echo '</p>';
			echo '</div>';
	
			echo $args['after_widget'];
		}

	}

}


?>